;Prueba de descompresion RLE 
; Desempaquetamos un SCR comprimido con RLE sobre la pantalla
ORG 35000
 
  ; Cargamos los datos y preparamos nuestra rutina
  LD HL, Pantalla_Comprimida
  LD DE, 16384
  LD BC, 2571
  CALL RLE_decompress


Wait_For_Keys_Pressed:
 XOR A                        ; A = 0
 IN A, (254)
 OR 224
 INC A
 JR Z, Wait_For_Keys_Pressed
 
salir:
  RET

;;
;; RLE_decompress
;; Descomprime un bloque de datos RLE de memoria a memoria.
;;
;; Entrada a la rutina:
;;
;; HL = dirección origen de los datos RLE.
;; DE = destino donde descomprimir los datos.
;; BC = tamaño de los datos comprimidos.
;;
RLE_decompress:
 
RLE_dec_loop:
   ld a,(hl)                          ; leemos un byte
 
   cp 192
   jp nc, RLE_dec_compressed          ; si byte > 192 = está comprimido
   ld (de), a                         ; si no está comprimido, escribirlo
   inc de
   inc hl
   dec bc
 
RLE_dec_loop2:
   ld a,b
   or c
   jr nz, RLE_dec_loop
   ret                                 ; miramos si hemos acabado
 
RLE_dec_compressed:                    ; bucle para descompresión
   push bc  
   and 63                              ; cogemos el numero de repeticiones
   ld b, a                             ; lo salvamos en B
   inc hl                              ; y leemos otro byte (dato a repetir)
   ld a, (hl)
 
RLE_dec_loop3:
   ld (de),a                           ; bucle de escritura del dato B veces
   inc de
   djnz RLE_dec_loop3
   inc hl
   pop bc                              ; recuperamos BC
   dec bc                              ; Este DEC BC puede hacer BC=0 si los datos
                                       ; RLE no correctos. Cuidado (mem-smashing).
   dec bc
   jr RLE_dec_loop2
   ret


Pantalla_Comprimida:
  INCBIN sokoban.rle


END 35000
